.nolist
include \masm32\include\masm32rt.inc
.list
CodeAlign macro nAlign:req,dbFill

	IFDEF algin_zero_lbl_code
		goto skip
	ELSE
		_TEXT SEGMENT
			align_mark_code:
			org 0
			algin_zero_lbl_code:
			org align_mark_code
		_TEXT ENDS
		_DATA SEGMENT
			align_mark_data:
			org 0
			algin_zero_lbl_data:
			org align_mark_data
		_DATA ENDS
		_BSS SEGMENT
			align_mark_bss:
			org 0
			algin_zero_lbl_bss:
			org align_mark_bss
		_BSS ENDS
	ENDIF
:skip
	;; check if power of two
	align_msk  = 2
	align_flag = 0
	REPEAT 31
		IF align_msk EQ nAlign
			align_flag = 1
			EXITM
		ENDIF
		align_msk = align_msk SHL 1
	ENDM
	IF align_flag EQ 0
		.err <ALIGN only to power of 2: 2,4,8,16,32,64...>
		EXITM
	ENDIF
	
	;; generate the bit mask
	align_msk = nAlign-1

	IFNB <dbFill>
		align_fill = dbFill
		IFIDNI @CurSeg,<_BSS>
			%echo warning :instructions and initialized data not supported in BSS segments
		ENDIF
	ELSE
		IFIDNI @CurSeg,<_TEXT>
			align_fill = 090h	; for .code  = nop
		ELSEIFIDNI @CurSeg,<_DATA>
			align_fill = 0		; for .data  = 0
		ENDIF
	ENDIF

	IFIDNI @CurSeg,<_TEXT>
		IF nAlign LE 16
			IFB <dbFill>
				IF (nAlign-(align_msk AND ($-OFFSET algin_zero_lbl_code))) EQ 5	; correct masm's align bug
					nop
					db 08Dh,74h,26h,0 ; lea esi,[esi+imm8(0)]
				ELSE
					align nAlign
				ENDIF
			ELSE
				db (nAlign-(align_msk AND ($-OFFSET algin_zero_lbl_code)))*(1 AND ((align_msk AND ($-OFFSET algin_zero_lbl_code)) NE 0)) dup (align_fill)
			ENDIF
		ELSE	;; align > 16
			db (nAlign-(align_msk AND ($-OFFSET algin_zero_lbl_code)))*(1 AND ((align_msk AND ($-OFFSET algin_zero_lbl_code)) NE 0)) dup (align_fill)
		ENDIF
	ELSEIFIDNI @CurSeg,<_DATA>
		db (nAlign-(align_msk AND ($-OFFSET algin_zero_lbl_data)))*(1 AND ((align_msk AND ($-OFFSET algin_zero_lbl_data)) NE 0)) dup (align_fill)
	ELSEIFIDNI @CurSeg,<_BSS>
		db (nAlign-(align_msk AND ($-OFFSET algin_zero_lbl_bss)))*(1 AND ((align_msk AND ($-OFFSET algin_zero_lbl_bss)) NE 0)) dup (?)
	ELSE
		.err <current segemnt not supported by _align-macro>
	ENDIF
endm

.code
start:
	REPEAT 3
	    inc eax
	ENDM
lbl8:
	CodeAlign 8
;	nop		; use for testing
	mov eax, $	; same as THIS NEAR
	and eax, 7
	print str$(eax), ": should be zero", 13, 10
	REPEAT 3
	    inc edx
	ENDM
lbl49:	mov eax, THIS NEAR	; loads lblThisNear
	mov edx, $		; loads EIP
	sub edx, 5		; account for mov edx, $
	.if eax!=edx
		print "$ and THIS NEAR seem to be different", 13, 10	; they are identical for ml, but not for JWasm
	.endif
	nop
	gdiff = $-start
	tmp$ CATSTR <global diff=>, %gdiff
	% echo tmp$
	CodeAlign 8		; diff 124, should be only 86
lblThisNear:
	mov eax, THIS NEAR	; same as $ - should be 49, not 64
	and eax, 7
	inkey str$(eax), ": should be zero", 13, 10
	exit
	;int 3
	; .err	; uncomment to test the macro
end start

;RichMasm options:
;OPT_DebugL	/MERGE:.data=.rdata /MERGE:.rdata=.text	; linker options for ultra short executables
;OPT_WAIT	0	; wait until a key is pressed before closing the DOS box
;OPT_Res	0	; no resources
;OxPT_Linker	polink	; shorter executables
;OPT_DelLst	0
;OPT_Assembler	JWasm
;OPT_Tmp2Asm	1

;8BFF	mov edi, edi		; 2-byte nop
;8D4900	lea ecx, [ecx+00]		; 3-byte nop
;8D642400	lea esp, [esp+00]		; 4-byte nop
;0500000000	add eax, 00000000		; 5-byte nop (may alter flags)
;8D9B00000000	lea ebx, [ebx+00000000]	; 6-byte nop
;8DA42400000000	lea esp, [esp+00000000]	; 7-byte nop

;OxPT_DebugA	/Zi	; activate symbols
;OxPT_Assembler	mlv615	; must be present in \bin
;OxPT_DebugL	/debug /debugtype:cv	; for debugging
;OxPT_Linker	linkv614	; must be present in \bin
